 /**
 * CodeNegar Roundabout Carousel Slider Style
 *
 * @package    	WordPress Carousel Slider
 * @license     http://codecanyon.net/licenses
 * @link		http://codenegar.com/roundabout-carousel-slider/
 * @version    	1.2
 */
 
function codenegar_make_roundabout($this){
	var options = new Object();
	
	options.responsive = true;
	options.postID = $this.attr("data-post_id");
	options.dropEasing = $this.attr("data-dropeasing");
	options.dropAnimateTo = $this.attr("data-dropanimateto");
	options.dragAxis = $this.attr("data-dragaxis");
	options.shape = $this.attr("data-shape");
	options.easing = $this.attr("data-easing");
	
	options.autoplay = ($this.attr("data-autoplay")=='on')? true : false;
	options.enableDrag = ($this.attr("data-enabledrag")=='on')? true : false;
	options.autoplayPauseOnHover = ($this.attr("data-autoplaypauseonhover")=='on')? true : false;
	options.responsive = ($this.attr("data-responsive")=='on')? true : false;
	
	options.duration = parseInt($this.attr("data-duration"));
	options.autoplayInitialDelay = parseInt($this.attr("data-autoplayinitialdelay"));
	options.autoplayDuration = parseInt($this.attr("data-autoplayduration"));
	options.dropDuration = parseInt($this.attr("data-dropduration"));
	options.dragFactor = parseInt($this.attr("data-dragfactor"));
	options.minZ = parseInt($this.attr("data-minz"));
	options.maxZ = parseInt($this.attr("data-maxz"));
	
	options.minOpacity = parseFloat($this.attr("data-minopacity"));
	options.maxOpacity = parseFloat($this.attr("data-maxopacity"));
	options.minScale = parseFloat($this.attr("data-minscale"));
	options.maxScale = parseFloat($this.attr("data-maxscale"));
	options.bearing = parseFloat($this.attr("data-bearing"));
	options.focusBearing = parseFloat($this.attr("data-focusbearing"));
	options.tilt = parseFloat($this.attr("data-tilt"));
	
	// Enable foucs event
	options.triggerFocusEvents = true;
	$this.roundabout(options);
	
	var enable_subtitle = ($this.attr("data-enable_subtitle")=='on')? true : false;
	
	if(enable_subtitle){
		var sub_fx = {
			show: $this.attr("data-subtitle_show_effect"),
			hide: $this.attr("data-subtitle_hide_effect")
		}
		jQuery("#" + $this.attr("id")).on('focus, animationEnd', function(){
			var focused_element = jQuery(this);
			var subtitle = focused_element.find(".cn-rcs-sub-data").html();
			jQuery(this).closest(".codenegar-rcs-element").siblings(".cn-rcs-sub")[sub_fx['hide']]().html(subtitle)[sub_fx['show']]();
		});
		
	}
	var enable_navigation = ($this.attr("data-enable_navigation")=='on')? true : false;
	if(enable_navigation){
		jQuery("#" + $this.attr("id")).on('focus, animationEnd', function(){
			var focused_element = jQuery(this);
			var slide_num = $this.roundabout("getChildInFocus") + 1; //it's zero-based so add 1
			jQuery(this).closest(".codenegar-rcs-element").siblings(".cn-rcs-nav").find("li.active").removeClass("active");
			jQuery(this).closest(".codenegar-rcs-element").siblings(".cn-rcs-nav").find("[data-order="+slide_num+"]").addClass("active");
		});
		
		$this.closest(".codenegar-rcs-element").siblings(".cn-rcs-nav").find("li").not(".active").click(function(e){
			e.preventDefault(); // contents may have a link
			var slide_num = jQuery(this).attr("data-order");
			if(slide_num>0){
				slide_num = slide_num -1; // we need zero-based slide number
				$this.roundabout("animateToChild", slide_num);
			}
		});
	}
	
	// trigger focus event at document ready
		jQuery("#" + $this.attr("id") + " li.roundabout-in-focus").trigger("focus");
}

(function($) {
$(document).ready(function() {
	$(function() {
		jQuery(".codenegar-rcs-element").each(function(){
			codenegar_make_roundabout(jQuery(this));
		});
	});
});
})(jQuery);